import { Argument, Creator, ProviderCallback, Module } from "./types";
import { Token } from "./token";
declare class Container {
    private dependencies;
    private providers;
    private requests;
    constructor();
    add<T>(token: Token<T>, creator: Creator<T>, args?: Argument[]): void;
    addAsync<T>(token: Token<T>, asyncCreator: Promise<Creator<T>>, args?: Argument[]): Promise<void>;
    share<T>(token: Token<T>, creator: Creator<T>, args?: Argument[]): void;
    shareAsync<T>(token: Token<T>, asyncCreator: Promise<Creator<T>>, args?: Argument[]): Promise<void>;
    constant<T>(token: Token<T>, value: T): void;
    constantAsync<T>(token: Token<T>, asyncValue: Promise<T>): Promise<void>;
    private registerAsync;
    private register;
    get<T>(token: Token<T>): T;
    getAsync<T>(token: Token<T>): Promise<T>;
    provide(tokens: Token[], provider: ProviderCallback): void;
    provideAsync(tokens: Token[], asyncProvider: Promise<ProviderCallback>): void;
    use(module: Creator<Module>): void;
    useAsync(asyncModule: Promise<Creator<Module>>): void;
    private instantiate;
    private instantiateAsync;
    private create;
    private createAsync;
    private createSingle;
    private createSingleAsync;
    private resolve;
    private resolveAsync;
    private construct;
}
declare function createContainer(): Container;
export { Container, createContainer };
