import { RawArgument } from "./raw";
import { Token } from "./token";
import { Container } from "./container";
export declare type Argument<T = unknown> = Token<T> | RawArgument<T>;
export declare type Constructor<T> = new (...args: any[]) => T;
export declare type Func<T> = (...args: any[]) => T;
export declare type Creator<T> = Constructor<T> | Func<T>;
export declare type Request = {
    token: Token;
    callback: () => void;
};
export declare type Dependency<T = unknown> = {
    token: Token<T>;
    creator: Creator<T>;
    args: Argument[];
    shared: boolean;
    instance?: any;
};
export declare type ProviderCallback = (container: Container) => void;
export declare type Provider = {
    tokens: Token[];
    called?: boolean;
    callback: () => void;
};
export declare type GetCallback<T> = (instance: T) => void;
export interface Module {
    provides: Token[];
    register: ProviderCallback;
}
